*Data libraries;

%macro setlibs;
%do year = 2006 %to 2010;
	libname car&year. "/disk/agedisk2/medicare/data/20pct/car/&year.";
	libname op&year. "/disk/agedisk2/medicare/data/20pct/op/&year.";
	libname med&year. "/disk/agedisk2/medicare/data/20pct/med/&year.";
	libname ip&year. "/disk/agedisk2/medicare/data/20pct/ip/&year.";
%end;
libname den2006 "/disk/agedisk2/medicare/data/20pct/den/2006";
libname den2007 "/disk/agedisk2/medicare/data/20pct/den/2007";
libname den2008 "/disk/agedisk2/medicare/data/20pct/den/2008";
libname ben2009 "/disk/agedisk2/medicare/data/20pct/bsf/2009";
libname ben2010 "/disk/agedisk2/medicare/data/20pct/bsf/2010";
libname input "/disk/agedisk5/medicare.work/afinkels-DUA22559/kluender/mergefiles/RiskScoreInputs";
libname partb "/disk/agedisk5/medicare.work/afinkels-DUA22559/kluender/mergefiles/MedicarePartsAandB";
%mend;
%setlibs;

* IP;
proc contents data=ip2006.ip_20_2006_clms1; run;
proc contents data=ip2009.ipc_2009_1; run;
proc contents data=ip2010.ipc2010; run;

* Specialist crosswalk;
proc contents data=partb.specialty_list; run;
proc contents data=partb.specialist_list_for_merge; run;

* Carrier;
proc contents data=input.spcl1998; run;
proc contents data=input.spcl2010; run;
proc contents data=car2006.car20_2006_clms1; run;
proc contents data=car2007.car20_2007_clms1; run; 
proc contents data=car2008.car20_2008_clms1; run; 
proc contents data=car2009.carc_2009_1; run;
proc contents data=car2010.carc2010; run;

* Outpatient;
proc contents data=op2006.op20_2006_clms1; run;
proc contents data=op2007.op20_2007_clms1; run;
proc contents data=op2008.op20_2008_clms1; run;
proc contents data=op2009.opc_2009_1; run;
proc contents data=op2010.opc2010; run;

* Outpatient;
proc contents data=op2006.op20_2006_revcntrs1; run;
proc contents data=op2007.op20_2007_revcntrs1; run;
proc contents data=op2008.op20_2008_revcntrs1; run;
proc contents data=op2009.opr_2009_1; run; 
proc contents data=op2010.opr2010; run;

* Medpar;
proc contents data=med2006.med20_2006_1; run;
proc contents data=med2007.med20_2007_1; run;
proc contents data=med2008.med20_2008_1; run;
proc contents data=med2009.med_2009_1; run;
proc contents data=med2010.med2010; run;

* Beneficiary;
proc contents data=den2006.den20_2006_57; run;
proc contents data=den2007.den20_2007_57; run;
proc contents data=den2008.den20_2008_57; run;
proc contents data=ben2009.bsf_2009_57; run;
proc contents data=ben2010.bsfab2010; run;










