/* These are macros that will generate annual data */

%macro stack(filepfx=, low=, high=);
	%do index=&low %to &high;
	  &filepfx&index
	%end;
%mend stack;

%macro GenerateCarrierYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data cartemp;
			set %stack(filepfx=car&year..car&pct._&year._clms,low=1,high=100);
			dgns_cd9 = '';
			dgns_cd10 = '';
			dgns_cd11 = '';
			dgns_cd12 = '';
		run;
	%end;

	%if &year. = 2009 %then %do;
		data cartemp;
			set %stack(filepfx=car2009.carc_2009_,low=1,high=100);
			dgns_cd9 = '';
			dgns_cd10 = '';
			dgns_cd11 = '';
			dgns_cd12 = '';
		run;
	%end;

	%if &year. = 2010 %then %do;
		data cartemp;
			set car2010.carc2010;
			rename 	icd_dgns_cd1 = dgns_cd1
					icd_dgns_cd2 = dgns_cd2
					icd_dgns_cd3 = dgns_cd3
					icd_dgns_cd4 = dgns_cd4
					icd_dgns_cd5 = dgns_cd5
					icd_dgns_cd6 = dgns_cd6
					icd_dgns_cd7 = dgns_cd7
					icd_dgns_cd8 = dgns_cd8
					icd_dgns_cd9 = dgns_cd9
					icd_dgns_cd10 = dgns_cd10
					icd_dgns_cd11 = dgns_cd11
					icd_dgns_cd12 = dgns_cd12;
		run;
	%end;

%mend GenerateCarrierYear;

%macro GenerateOpClmsYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data optemp;
			set %stack(filepfx=op&year..op&pct._&year._clms,low=1,high=100);
			dgnscd11 = '';
			dgnscd12 = '';
			dgnscd13 = '';
			dgnscd14 = '';
			dgnscd15 = '';
			dgnscd16 = '';
			dgnscd17= '';
			dgnscd18 = '';
			dgnscd19 = '';
			dgnscd20 = '';
			dgnscd21 = '';
			dgnscd22 = '';
			dgnscd23 = '';
			dgnscd24 = '';
			dgnscd25 = '';
		run;
	%end;
	
	%if &year. = 2009 %then %do;
		data optemp;
			set %stack(filepfx=op2009.opc_2009_,low=1,high=100);
			dgnscd11 = '';
			dgnscd12 = '';
			dgnscd13 = '';
			dgnscd14 = '';
			dgnscd15 = '';
			dgnscd16 = '';
			dgnscd17= '';
			dgnscd18 = '';
			dgnscd19 = '';
			dgnscd20 = '';
			dgnscd21 = '';
			dgnscd22 = '';
			dgnscd23 = '';
			dgnscd24 = '';
			dgnscd25 = '';
		run;
	%end;

	%if &year. = 2010 %then %do;
		data optemp;
			set op2010.opc2010;
			rename 	icd_dgns_cd1 = dgnscd1
					icd_dgns_cd2 = dgnscd2
					icd_dgns_cd3 = dgnscd3
					icd_dgns_cd4 = dgnscd4
					icd_dgns_cd5 = dgnscd5
					icd_dgns_cd6 = dgnscd6
					icd_dgns_cd7 = dgnscd7
					icd_dgns_cd8 = dgnscd8
					icd_dgns_cd9 = dgnscd9
					icd_dgns_cd10 = dgnscd10
					icd_dgns_cd11 = dgnscd11
					icd_dgns_cd12 = dgnscd12
					icd_dgns_cd13 = dgnscd13
					icd_dgns_cd14 = dgnscd14
					icd_dgns_cd15 = dgnscd15
					icd_dgns_cd16 = dgnscd16
					icd_dgns_cd17 = dgnscd17
					icd_dgns_cd18 = dgnscd18
					icd_dgns_cd19 = dgnscd19
					icd_dgns_cd20 = dgnscd20
					icd_dgns_cd21 = dgnscd21
					icd_dgns_cd22 = dgnscd22
					icd_dgns_cd23 = dgnscd23
					icd_dgns_cd24 = dgnscd24
					icd_dgns_cd25 = dgnscd25;
		run;
	%end;
	
%mend GenerateOpClmsYear;

%macro GenerateOPRevCntrYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data oprevtemp;
			set %stack(filepfx=op&year..op&pct._&year._revcntrs,low=1,high=100);
		run;
	%end;
	
	%if &year. = 2009 %then %do;
		data oprevtemp;
			set %stack(filepfx=op2009.opr_2009_,low=1,high=100);
		run;
	%end;

	%if &year. = 2010 %then %do;
		data oprevtemp;
			set op2010.opr2010;
		run;
	%end;
	
%mend GenerateOPRevCntrYear;

%macro GenerateIPRevCntrYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data iprevtemp;
			set %stack(filepfx=ip&year..ip&pct._&year._revcntrs,low=1,high=100);
		run;
	%end;
	
	%if &year. = 2009 %then %do;
		data iprevtemp;
			set %stack(filepfx=ip2009.ipr_2009_,low=1,high=100);
		run;
	%end;

	%if &year. = 2010 %then %do;
		data iprevtemp;
			set ip2010.ipr2010;
		run;
	%end;
	
%mend GenerateIPRevCntrYear;

%macro GenerateMedClmsYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data medtemp;
			set %stack(filepfx=med&year..med&pct._&year._,low=1,high=100);
		run;
	%end;
	
	%if &year. = 2009 %then %do;
		data medtemp;
			set %stack(filepfx=med2009.med_2009_,low=1,high=100);
		run;
	%end;

	%if &year. = 2010 %then %do;
		data medtemp;
			set med2010.med2010;
		run;
	%end;
	
%mend GenerateMedClmsYear;

%macro GenerateBeneYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data benetemp;
			set %stack(filepfx=den&year..den&pct._&year._,low=1,high=100);
		run;

		data benetemp;
			set benetemp;
			if buyin01 = 'B' or buyin01 = 'C' then mcaid01 = 1;
				else mcaid01 = 0;
			if buyin02 = 'B' or buyin02 = 'C' then mcaid02 = 1;
				else mcaid02 = 0;
			if buyin03 = 'B' or buyin03 = 'C' then mcaid03 = 1;
				else mcaid03 = 0;
			if buyin04 = 'B' or buyin04 = 'C' then mcaid04 = 1;
				else mcaid04 = 0;
			if buyin05 = 'B' or buyin05 = 'C' then mcaid05 = 1;
				else mcaid05 = 0;
			if buyin06 = 'B' or buyin06 = 'C' then mcaid06 = 1;
				else mcaid06 = 0;
			if buyin07 = 'B' or buyin07 = 'C' then mcaid07 = 1;
				else mcaid07 = 0;
			if buyin08 = 'B' or buyin08 = 'C' then mcaid08 = 1;
				else mcaid08 = 0;
			if buyin09 = 'B' or buyin09 = 'C' then mcaid09 = 1;
				else mcaid09 = 0;
			if buyin10 = 'B' or buyin10 = 'C' then mcaid10 = 1;
				else mcaid10 = 0;
			if buyin11 = 'B' or buyin11 = 'C' then mcaid11 = 1;
				else mcaid11 = 0;
			if buyin12 = 'B' or buyin12 = 'C' then mcaid12 = 1;
				else mcaid12 = 0;
		run;
		
		data benetemp;
			set benetemp;
			mcaid_count = mcaid01 + mcaid02 + mcaid03 + mcaid04
						+ mcaid05 + mcaid06 + mcaid07 + mcaid08
						+ mcaid09 + mcaid10 + mcaid11 + mcaid12;
		run;
		
		data benetemp;
			set benetemp;
			if mcaid_count>0 then mcaid = 1;
				else mcaid = 0;
			nemcaid = 0;
		run;
		
		proc sort data=benetemp nodupkey;
			by bene_id;
		run;
		
	%end;
	
	%if &year. = 2009 %then %do;
		data benetemp;
			set %stack(filepfx=ben2009.bsf_2009_,low=1,high=100);
		run;
		
		data benetemp;
			set benetemp;
			if buyin01 = 'B' or buyin01 = 'C' then mcaid01 = 1;
				else mcaid01 = 0;
			if buyin02 = 'B' or buyin02 = 'C' then mcaid02 = 1;
				else mcaid02 = 0;
			if buyin03 = 'B' or buyin03 = 'C' then mcaid03 = 1;
				else mcaid03 = 0;
			if buyin04 = 'B' or buyin04 = 'C' then mcaid04 = 1;
				else mcaid04 = 0;
			if buyin05 = 'B' or buyin05 = 'C' then mcaid05 = 1;
				else mcaid05 = 0;
			if buyin06 = 'B' or buyin06 = 'C' then mcaid06 = 1;
				else mcaid06 = 0;
			if buyin07 = 'B' or buyin07 = 'C' then mcaid07 = 1;
				else mcaid07 = 0;
			if buyin08 = 'B' or buyin08 = 'C' then mcaid08 = 1;
				else mcaid08 = 0;
			if buyin09 = 'B' or buyin09 = 'C' then mcaid09 = 1;
				else mcaid09 = 0;
			if buyin10 = 'B' or buyin10 = 'C' then mcaid10 = 1;
				else mcaid10 = 0;
			if buyin11 = 'B' or buyin11 = 'C' then mcaid11 = 1;
				else mcaid11 = 0;
			if buyin12 = 'B' or buyin12 = 'C' then mcaid12 = 1;
				else mcaid12 = 0;
		run;
		
		data benetemp;
			set benetemp;
			mcaid_count = mcaid01 + mcaid02 + mcaid03 + mcaid04
						+ mcaid05 + mcaid06 + mcaid07 + mcaid08
						+ mcaid09 + mcaid10 + mcaid11 + mcaid12;
		run;
		
		data benetemp;
			set benetemp;
			if mcaid_count>0 then mcaid = 1;
				else mcaid = 0;
			nemcaid = 0;
		run;
		
		proc sort data=benetemp nodupkey;
			by bene_id;
		run;
		
	%end;

	%if &year. = 2010 %then %do;
		data benetemp;
			set ben2010.bsfab2010;
			if buyin01 = 'B' or buyin01 = 'C' then mcaid01 = 1;
				else mcaid01 = 0;
			if buyin02 = 'B' or buyin02 = 'C' then mcaid02 = 1;
				else mcaid02 = 0;
			if buyin03 = 'B' or buyin03 = 'C' then mcaid03 = 1;
				else mcaid03 = 0;
			if buyin04 = 'B' or buyin04 = 'C' then mcaid04 = 1;
				else mcaid04 = 0;
			if buyin05 = 'B' or buyin05 = 'C' then mcaid05 = 1;
				else mcaid05 = 0;
			if buyin06 = 'B' or buyin06 = 'C' then mcaid06 = 1;
				else mcaid06 = 0;
			if buyin07 = 'B' or buyin07 = 'C' then mcaid07 = 1;
				else mcaid07 = 0;
			if buyin08 = 'B' or buyin08 = 'C' then mcaid08 = 1;
				else mcaid08 = 0;
			if buyin09 = 'B' or buyin09 = 'C' then mcaid09 = 1;
				else mcaid09 = 0;
			if buyin10 = 'B' or buyin10 = 'C' then mcaid10 = 1;
				else mcaid10 = 0;
			if buyin11 = 'B' or buyin11 = 'C' then mcaid11 = 1;
				else mcaid11 = 0;
			if buyin12 = 'B' or buyin12 = 'C' then mcaid12 = 1;
				else mcaid12 = 0;
		run;
		
		data benetemp;
			set benetemp;
			mcaid_count = mcaid01 + mcaid02 + mcaid03 + mcaid04
						+ mcaid05 + mcaid06 + mcaid07 + mcaid08
						+ mcaid09 + mcaid10 + mcaid11 + mcaid12;
		run;
		
		data benetemp;
			set benetemp;
			if mcaid_count>0 then mcaid = 1;
				else mcaid = 0;
			nemcaid = 0;
		run;
		
		proc sort data=benetemp nodupkey;
			by bene_id;
		run;
		
	%end;
	
%mend GenerateBeneYear;

%macro GenerateIpClmsYear(year=, pct=);

	%if &year.>=2006 and &year.<=2008 %then %do;
		data iptemp;
			set %stack(filepfx=ip&year..ip&pct._&year._clms,low=1,high=100);
		run;
	%end;
	
	%if &year. = 2009 %then %do;
		data iptemp;
			set %stack(filepfx=ip2009.ipc_2009_,low=1,high=100);
		run;
	%end;

	%if &year. = 2010 %then %do;
		data iptemp;
			set ip2010.ipc2010;
		run;
	%end;
	
%mend GenerateOpClmsYear;