clear
set more off

global file_path /disk/agedisk3/medicare.work/finkels-DUA22559/tangb/contract_design/code/RiskScoreOutputs/MedicarePartsAandB/

use ${file_path}/spcllist, clear
    
** Make sure we drop the UPINs and NPIs that are clearly wrong
** UPINs are 6 digits, NPIs are 10 digits
gen npi_len = length(at_npi)
	replace at_npi = "" if npi_len != 10
drop npi_len

foreach err in 0000000000 9999999999 9999999996 9999999992 1111111112 0000000001 9999999991 ///
9999999995 0000000009{
	replace at_npi = "" if at_npi == "`err'"
}
drop if at_upin == "" & at_npi == ""

gen specialist = 1
	foreach code in 01 08 11 25 32 37 38 64 42 43 44 49 50 51 52 53 54 55 56 57 58 59 74 ///
			60 61 63 65 67 69 70 71 72 73 75 79 80 81 88 35 89 95 97 99 A0 A5 93 {
		replace specialist = 0 if spcl=="`code'"
	}

collapse (max) specialist, by(at_npi)

save ${file_path}/specialist_list_for_merge, replace



